﻿using System;
using System.Windows.Forms;

namespace HeuristicLab.DataPreprocessing.Views {
  public partial class FindAndReplaceDialog : Form {
    public FindAndReplaceDialog() {
      InitializeComponent();
      string[] cmbItems = { "Value", "Average", "Median", "Random", "Most Common", "Interpolation" };
      cmbReplaceWith.Items.AddRange(cmbItems);
    }

    public void ActivateSearch() {
      tabSearch.Focus();
      AddControlsToCurrentTab();
    }

    public void ActivateReplace() {
      tabReplace.Focus();
      AddControlsToCurrentTab();
    }

    private void tabSearchReplace_SelectedIndexChanged(object sender, System.EventArgs e) {
      AddControlsToCurrentTab();
    }

    private void AddControlsToCurrentTab() {
      tabSearchReplace.SelectedTab.Controls.Add(btnFindAll);
      tabSearchReplace.SelectedTab.Controls.Add(btnFindNext);
      tabSearchReplace.SelectedTab.Controls.Add(lblSearch);
      tabSearchReplace.SelectedTab.Controls.Add(txtSearchString);
    }

    public string GetSearchText() {
      return txtSearchString.Text;
    }

    public string GetReplaceText() {
      return txtValue.Text;
    }

    public string GetReplaceAction() {
      return cmbReplaceWith.SelectedText;
    }

    public event EventHandler FindAllEvent {
      add { btnFindAll.Click += value; }
      remove { btnFindAll.Click -= value; }
    }

    public event EventHandler FindNextEvent {
      add { btnFindNext.Click += value; }
      remove { btnFindNext.Click -= value; }
    }

    public event EventHandler ReplaceAllEvent {
      add { btnReplaceAll.Click += value; }
      remove { btnReplaceAll.Click -= value; }
    }

    public event EventHandler ReplaceNextEvent {
      add { btnReplaceNext.Click += value; }
      remove { btnReplaceNext.Click -= value; }
    }
      
  }
}
